// LogView.cpp
#include <afxcmn.h>
#include <afxext.h> //for the splitter window
#include <afxdlgs.h>

#include "MainWin.h"		//the Main Class
#include "Dialog.h"
#include "LogView.h"		//the Log view class
#include "resources.h"		//for the ID of the menus

#define SOCK_LISTEN_EVENT	WM_USER+7
#define SOCK_DATA_EVENT		WM_USER+5
#define SOCK_CONTROL_EVENT	WM_USER+3

#define BUFFSIZE 1024

//from the main.cpp

#define SOCK_LISTEN_FRAME_EVENT	 WM_USER+9
#define SOCK_DATA_FRAME_EVENT	 WM_USER+11
#define SOCK_CONTROL_FRAME_EVENT WM_USER+13


OPENFILENAME m_ofn;

int  bin_stat=1, ASCII_stat=0;


BOOL IsConnected = FALSE;
BOOL IfCancel = FALSE;
	
BOOL ReceiveFile = FALSE;
BOOL FileReceived = FALSE;

BOOL SendFile = FALSE;
BOOL FileSent = FALSE;

BOOL What; //for dialogs


IMPLEMENT_DYNCREATE(C_LogView, CEditView)

/**********************************************************/
BEGIN_MESSAGE_MAP(C_LogView, CEditView)
//LogView buttons
//POPUP CONNECT

	ON_COMMAND(IDM_CONNECT_SOCK,OnConnect)	// to start the connection dialog
	ON_COMMAND(IDM_CLOSE_SOCK,DISCONNECT)	
	ON_COMMAND(IDM_MAIL, SendMail)
	ON_COMMAND(IDM_OnEXIT, On_Exit)	//exit program

	ON_COMMAND(IDT_SENDFILE, Menu_UpLoad)
	ON_COMMAND(IDT_RECEIVEFILE, Menu_DownLoad)
	ON_COMMAND(IDT_CANCEL, CancelTransfer)

	ON_COMMAND(IDH_ABOUT,OnAbout)
	//POPUP SETTINGS

	ON_COMMAND(IDS_SETTINGS,OnTransferMode)

//messages for the asychronous commu

	ON_MESSAGE( SOCK_CONTROL_EVENT, CtlrMessage)	//receive the message from the port
	ON_MESSAGE( SOCK_DATA_EVENT, DataMessage )
	ON_MESSAGE( SOCK_LISTEN_EVENT, ListenMessage)

	ON_WM_CHAR()
//}
END_MESSAGE_MAP()

/**********************************************************/
BOOL C_LogView::PreCreateWindow(CREATESTRUCT& cs)
{
	
	BOOL bPreCreated = CEditView::PreCreateWindow(cs);

	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	cs.style |=	ES_READONLY; // make read only - it is a log window
	return TRUE;
}

/**********************************************************/
//Constructor
C_LogView ::C_LogView()
{

	if(WSAStartup(0x0101, &ws)) //start the library
			MessageBox("Unable to initialize Winsock Library","Failure...",MB_OK);	

	user_head = "USER "; //added to user name
		
	pass_head = "PASS "; //for pass

	tail= "\r\n";	//added to both user and pass
		
	ImageList.Create(FILE_BMP, 13,1,CLR_NONE);
	//List->SetImageList(&ImageList, LVSIL_SMALL);

}

/**********************************************************/
/////////// THE WM_PAINT FUCTION
void C_LogView::OnDraw(CDC *DC)
{
// empty OnDraw function
}


/**********************************************************/
/////////////when Connect is selected from the menu
afx_msg void C_LogView::OnConnect()
{

	C_Dialog diagOb("CONNECT_DIALOG",this);
	diagOb.DoModal();
	
	if( !IfCancel )
	{
		Connect_Info();
		IfCancel = TRUE;
	}
	

}

/**********************************************************/
////////////	when disconnecting from the server
afx_msg void C_LogView:: DISCONNECT()
{
	closesocket(sock_data);
	closesocket(sock_listen);
	closesocket(sock_ctrl);
	IsConnected = FALSE;
	WSACleanup();
}  

/**********************************************************/
/////////////// SEND MAIL
void C_LogView ::SendMail()
{
	C_Dialog diagOb("IDD_MAIL",this);
	diagOb.DoModal();
}

/**********************************************************/
///////////// for exit ////////////////////////
afx_msg void C_LogView::On_Exit()
{
	int i;
	i=MessageBox("Are You Sure You Want To Exit?","Exit?", MB_YESNO | MB_ICONQUESTION);
	C_MainWin * pFWnd = (C_MainWin * )AfxGetMainWnd();
	switch(i)
	{
	case IDYES:
		pFWnd->SendMessage(WM_CLOSE);
		break;

	case IDNO:
		break;
	}
}

/**********************************************************/
//to cancel the transfer
void C_LogView ::CancelTransfer()
{
	IfCancel = TRUE;
}

/**********************************************************/
/////////////////display the "Open" Dialog when uploading
void C_LogView::UpLoad()
{

	
	CFileDialog dlg(TRUE,"zip","imran",OFN_CREATEPROMPT | OFN_EXPLORER | OFN_LONGNAMES | OFN_OVERWRITEPROMPT);
	dlg.DoModal();
	UpLoadPath = dlg.GetPathName();


}

/**********************************************************/
/////////////////display the "file asking" Dialog when uploading
afx_msg void C_LogView::Menu_UpLoad()
{
	
	What =1;
	C_Loading diagOb("IDM_ONSERVER",this);
	diagOb.DoModal();	
	
	
}

/**********************************************************/
/////////////////display the "file asking" Dialog when uploading
afx_msg void C_LogView::Menu_DownLoad()
{	
	What = 2;
	C_Loading diagOb("IDM_ONSERVER",this);
	diagOb.DoModal();	
	
}

/**********************************************************/
//display the save as dialog when downloding
void C_LogView::DownLoad()
{
	CFileDialog dlg(FALSE,"zip","imran",OFN_HIDEREADONLY |OFN_CREATEPROMPT | OFN_EXPLORER | OFN_LONGNAMES | OFN_OVERWRITEPROMPT);
	dlg.DoModal();
	DnLoadPath = dlg.GetPathName();
	 
}

/**********************************************************/
///////////////ABOUT
afx_msg void C_LogView::OnAbout()
{
	C_Dialog diagOb("IDD_HELP", this);
	diagOb.DoModal();
	
//	MessageBox("MAX FTP \r\nCreated By IMRAN NAZIR\r\nCopyright (c) 1999","About",MB_OK );
}

/**********************************************************/
afx_msg void C_LogView::OnTransferMode()
{
	C_Transfer diagOb("TRANSFER_DIALOG",this);
	diagOb.DoModal();
}


//the WM_CHAR to block input to the view
afx_msg void C_LogView::OnChar(UINT chr,UINT count,UINT flags)
{
//	SetFocus();
}


///////////////adding item to the list
void C_LogView::Add_List(CString CS)
{
	List = (CListCtrl *)GetDlgItem(IDC_LISTVIEW);	
//	List->InsertColumn(0, "IMRAN", LVCFMT_LEFT, 96);
//	i++;

}


/**********************************************************/
/////////	to connect to the host; called after the Connect from the menu
void C_LogView :: Connect_Info()
{

	int con_handle;		//connection handle
	struct sockaddr_in Sa;
	struct hostent *H; //for the gethost by name func


	// create socket
	if( (sock_ctrl = socket(PF_INET,SOCK_STREAM,IPPROTO_TCP)) == INVALID_SOCKET)
		MessageBox("Unable to Create Socket","Failure...",MB_OK | MB_ICONSTOP | MB_ICONSTOP);	

	H = gethostbyname(site_addr);
	
	if( (WSAGetLastError() == WSAHOST_NOT_FOUND))
	{
		MessageBox("Unable to Resolve Host Name","Failure...",MB_OK | MB_ICONSTOP | MB_ICONSTOP);	
		return;
	}

	Sa.sin_family = AF_INET;
	Sa.sin_addr.s_addr =*((unsigned long *)H->h_addr);
	Sa.sin_port = htons(21);

	//select the events to be monitered
	WSAAsyncSelect( sock_ctrl, AfxGetMainWnd()->m_hWnd,SOCK_CONTROL_FRAME_EVENT,FD_READ | FD_WRITE | FD_CLOSE);

	//connect
	con_handle = connect(sock_ctrl, (struct sockaddr *) &Sa, sizeof(Sa));	
	
	if( (con_handle == WSAECONNREFUSED) || (con_handle == WSAETIMEDOUT))
		MessageBox("Unable to Connect","Failure...",MB_OK | MB_ICONSTOP);	
	
	else
		IsConnected = TRUE;

	return;	
} 

/**********************************************************/
////////////////    when a command is send
void C_LogView::Send_Command(CString szBuffer)
{

	
	struct sockaddr_in S_ctrl;	//to get the IP address from the control socket
	struct sockaddr_in S_listen; // to get the assigned port to the listen socket

	SetFocus();

	szBuffer += tail;
	int iLength = sizeof(S_ctrl);

	CString for_port = "PORT ";	//for port command
	CString mCmd;

	char *ip;			//to store IP
	char *port;			//to get port of the bound sock
	

	sock_listen = Bind();	// bind the listen socket

	WSAAsyncSelect(sock_listen, AfxGetMainWnd()->m_hWnd, SOCK_LISTEN_FRAME_EVENT, FD_ACCEPT | FD_CLOSE );

	listen(sock_listen, 3); //to put the socket in listen mode

	if(getsockname(sock_ctrl, (sockaddr *)&S_ctrl, &iLength)) 
		MessageBox("Unable to read a socket", "Error", MB_OK);

	iLength = sizeof(S_ctrl);

	if(getsockname(sock_listen, (sockaddr *)&S_listen, &iLength)) 
		MessageBox("Unable to read a socket", "Error", MB_OK);

	port = (char *)&S_listen.sin_port;
	ip	 = (char *)&S_ctrl.sin_addr;	
	
	#define  UC(b)  (((int)b)&0xff)
		
	for_port.Format( "PORT %d,%d,%d,%d,%d,%d\r\n",
				UC(ip[0]), UC(ip[1]), UC(ip[2]), UC(ip[3]),
				UC(port[0]), UC(port[1]) );
	
	send(sock_ctrl,for_port, strlen(for_port),0);

	mCmd = szBuffer;
	mCmd = mCmd.Left(4);
	mCmd.MakeUpper();

	if( mCmd == "RETR" || mCmd == "STOR")
	{
		if(mCmd == "RETR")
		{
				ReceiveFile = TRUE;
				FileReceived = FALSE;
				IfCancel = FALSE;
				DownLoad();
		}

		if(mCmd == "STOR")
		{
				SendFile = TRUE;
				FileSent = FALSE;
				IfCancel = FALSE;

				/*CString sTemp;
				sTemp = szBuffer;
				sTemp = sTemp.Right( sTemp.GetLength() - 5);
				sTemp.TrimRight();
				sTemp.TrimLeft();
				m_sStoringFilePath = sTemp;*/

				
				UpLoad();
		}

		if(bin_stat == 1)
		{
			mCmd = "TYPE I\r\n";
			send(sock_ctrl,mCmd, strlen(mCmd),0);	
		}	

		if(bin_stat == 0)
		{
			mCmd = "TYPE A\r\n";
			send(sock_ctrl,mCmd, strlen(mCmd),0);
		}
	
	}
	
	send(sock_ctrl,szBuffer, strlen(szBuffer),0);
}

/**********************************************************/
///////////////when any new command is issued.to bind the socket
SOCKET C_LogView::Bind()
{
	struct sockaddr_in server; //for the server info
	SOCKET s;			//dummy socket
	
	//create a socket
	if(	(s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET)
		MessageBox("Unable to create a listen socket", "Error", MB_OK);

		server.sin_family      = AF_INET; //family type
		server.sin_addr.s_addr = INADDR_ANY; 
		server.sin_port        = htons(0);	//0 port for default
	
	if( bind(s, (sockaddr *)&server, sizeof(server)) < 0 )
		MessageBox("Unable to bind socket", "Error", MB_OK);

	setsockopt( s, SOL_SOCKET, SO_LINGER, 0, 0 );	
	setsockopt( s, SOL_SOCKET, SO_REUSEADDR, 0, 0 );
	setsockopt( s, SOL_SOCKET, SO_KEEPALIVE, 0, 0 );

	return s;

}


/**********************************************************/
///////////////to display the command
void C_LogView:: PrintDisplay(char *data_recv_buffer)
{
	CString dummy;

	char * str=strtok(data_recv_buffer,"\n"); //search for first \n in buffer
	
	while( str && *str) //while length is not null and pointer is not null
	{
		

	int nChars=GetWindowTextLength();    // get the index of the last line

	dummy = str;
	dummy += tail;

 	// point end of document
	GetEditCtrl().SetSel( nChars,nChars );
	GetEditCtrl().ReplaceSel(dummy);     // display text
	
	str=strtok((char *)NULL,"\n");
	}		
	*data_recv_buffer = 0;

}//end of data print

/**********************************************************/
/////////////// for the messages of the control socket
afx_msg void C_LogView :: CtlrMessage(WPARAM wParam, LPARAM lParam)
{	
	CClientDC dc(this);
	ASSERT( sock_ctrl == wParam );

	memset( ctrl_recv_buffer, 0, BUFFSIZE+2);

	// this memset trick avoids having strtok insert a wild \0 somewhere bad
	//		it is guaranteed to find a \n (the delimiter in this case) before
	//		running off into other memory
	
	memset( ctrl_recv_buffer+BUFFSIZE, '\n', 1); 


	switch(WSAGETSELECTEVENT(lParam))
	{

	case FD_READ:		//read any incoming
		recv(sock_ctrl, ctrl_recv_buffer, BUFFSIZE,0);	
		
		PrintDisplay(ctrl_recv_buffer);
		break;


	case FD_WRITE:		//only when this is created
		send(sock_ctrl, FINAL_USER, strlen(FINAL_USER) , 0 );
		send(sock_ctrl, FINAL_PASS, strlen(FINAL_PASS) , 0 );
		break;

	case FD_CLOSE:		//when the close command is sent
		MessageBox("Connection Closed",NULL,MB_OK);
		closesocket(sock_ctrl);
		break;

	default:
		break;

	
	}
}//end of control message

/**********************************************************/
/////////////// to listen the port
afx_msg void C_LogView:: ListenMessage(WPARAM wParam, LPARAM lParam)
{
	
	switch(WSAGETSELECTEVENT(lParam))
	{

	case FD_ACCEPT:		//to accept the connection being initiated by server
		sock_data = accept( sock_listen, NULL, NULL);
		
		setsockopt( sock_data, SOL_SOCKET, SO_LINGER, 0, 0);	
		setsockopt( sock_data, SOL_SOCKET, SO_REUSEADDR, 0, 0);
		setsockopt( sock_data, SOL_SOCKET, SO_KEEPALIVE, 0, 0);
		
		WSAAsyncSelect(sock_data, AfxGetMainWnd()->m_hWnd, SOCK_DATA_FRAME_EVENT,FD_READ | FD_WRITE);
		break;

	case FD_CLOSE:		//when closing the socket
		closesocket(sock_listen);
		break;

	default:
		break;
	}
}//end of listen socket messages

/**********************************************************/

//////////////// asynchronous function for data reading
afx_msg void C_LogView::DataMessage(WPARAM wParam, LPARAM lParam)
{

	CClientDC dc(this);
	
	memset( data_recv_buffer, 0, BUFFSIZE+2);

	// this memset trick avoids having strtok insert a wild \0 somewhere bad
	//	it is guaranteed to find a \n (the delimiter in this case) before
	//	running off into other memory
	
	memset( data_recv_buffer+BUFFSIZE, '\n', 1); 

	switch(	WSAGETSELECTEVENT(lParam) )
	{

	case FD_READ:		//when there is data at port
		if(!ReceiveFile)
		{
		recv(sock_data, data_recv_buffer, BUFFSIZE,0);
		PrintDisplay(data_recv_buffer);
		
	//	data = data_recv_buffer;
		Parse(data_recv_buffer);
		
		}
		
		else
		{
//			    MessageBox("FileComing", NULL,MB_OK);
				RecieveIncomingFile();

		}

		break;

	case FD_WRITE:
		if(SendFile)
			{
			SendGoingFile();
			SendFile=FALSE;
			}
			
		break;

	default:
		break;


	}
}//end of data messages


///////////////to receive flle
/**********************************************************/
void C_LogView::RecieveIncomingFile()
{
	int nRet,nLen;
	char *str;
	
	//	FOR IMAGE TYPE TRANSFER

	BeginWaitCursor();
	
	if(IfCancel)
	{
		closesocket(sock_data);
		IfCancel = FALSE;
	}

	if(!IfCancel && !ASCII_stat)
	{
		//MessageBox("Inside",NULL,MB_OK);
		ptr = fopen(DnLoadPath,"wb");
		
		if(ptr)
		{
			do
			{
			nRet = recv(sock_data, data_recv_buffer, BUFFSIZE,0);
	
				if(sock_data !=INVALID_SOCKET || nRet > 0 )
				{		
				PrintDisplay(data_recv_buffer);
				fwrite( (char *)data_recv_buffer, sizeof( char ),nRet, ptr);
				}
		
			}while(sock_data !=INVALID_SOCKET && nRet > 0 );
		
			fclose(ptr);
			ptr = NULL;
		
		}
		
	}

	//	FOR ASCII TRANSFER

	if( !IfCancel && ASCII_stat)
	{	
//		MessageBox("Inside",NULL,MB_OK);
		ptr = fopen(DnLoadPath,"w");

		if(ptr)
		{
			do {
				memset(data_recv_buffer,0,BUFFSIZE+2);
				// this memset trick avoids having strtok insert a wild \0 somewhere bad
				//		it is guaranteed to find a \n (the delimiter in this case) before
				//		running off into other memory
				memset(data_recv_buffer+BUFFSIZE, '\n', 1); 
				PrintDisplay(data_recv_buffer);
				nRet = recv( sock_data,data_recv_buffer, BUFFSIZE, 0 );
				if( nRet != SOCKET_ERROR && nRet > 0 )
				{
					str=strtok(data_recv_buffer,"\n");
					while( str && *str)
					{
						char temp[BUFFSIZE+1];
						strcpy( temp, str);
						nLen = strlen(str);
						if( nLen > 0 )
						{
							if( *( str + nLen - 1 ) == 0x0d) // remove the 0x0d aka \r
							{
								*( str + nLen - 1 ) = 0;
								fprintf( ptr, "%s\n", str );
							}
							else
							{
								fprintf( ptr, "%s", str );
							}
						}
						str=strtok((char *)NULL,"\n");
					}
				}
			}while(sock_data !=INVALID_SOCKET && nRet > 0 );
		
			fclose(ptr);	
			ptr = NULL;
		}
	}


	ReceiveFile = FALSE;
	FileReceived = TRUE;
	sock_data = INVALID_SOCKET;
	EndWaitCursor();

}

/**********************************************************/
///////////////when sending a file
void C_LogView::SendGoingFile()
{
	int nr;
	CString sOut;

	if(IfCancel)
	{
		closesocket(sock_data);
		IfCancel = FALSE;
	}

	ptr = fopen(UpLoadPath, "rb" );
	if( !ptr )
	{
		sOut.Format( "Specifed file\n%s\ncannot be found", m_sStoringFilePath );
		if( AfxMessageBox( sOut ) == IDOK )
		{
			SendFile = FALSE;
			return;
		}
	}
	
	else
	{
		do
		{	
			nr = fread( (char *)data_recv_buffer, sizeof( char ), BUFFSIZE, ptr ); 
			if( nr > 0 )
			{
				send( sock_data, data_recv_buffer, nr, 0);
			}
		} while( nr > 0 && !IfCancel);
	}

	SendFile = FALSE;
	FileSent = TRUE;

	fclose( ptr );
	ptr = NULL;
	
	closesocket(sock_data);
	sock_data= INVALID_SOCKET;
}

/**********************************************************/
void C_LogView::Parse(char *DD)
{
	char *ch;
	CString SS;
	int i;
	int len;
	int what;
			
	do{	
	ch = strtok(DD, "\r\n");
	
	SS = ch;

	what = SS.Find("-r");
	
	len = SS.GetLength();

	i = SS.ReverseFind(' ');

	SS = SS.Right(len-i);

	
	List = (CListCtrl *)GetDlgItem(IDC_LISTVIEW);	
	//List->InsertColumn(0, SS, LVCFMT_LEFT, 96);
	i++;

	ch = strtok(NULL,"\r\n");

	}while(ch);
}

/**********************************************************/
/////////// THE CONNECTION DIALOG ///////////
// WHEN OK FOR CONNECTION
BEGIN_MESSAGE_MAP(C_Dialog, CDialog)
//{
	ON_COMMAND(ID_OK, Make_Connect)	// OK to make connection
	ON_COMMAND(EMAIL_OK, OnMailOK)
//}
END_MESSAGE_MAP()

/**********************************************************/
afx_msg void C_Dialog :: Make_Connect() 
{
	CEdit *siteptr,*userptr, *passptr;

	
	//the pointer for the C_MainWin class
	C_MainWin *mainPtr = (C_MainWin *)AfxGetMainWnd();
	ASSERT(mainPtr != NULL);
	
	//the pointer for the C_LofView class
	C_LogView *LogPtr = (C_LogView *)(mainPtr->m_wndSplitter.GetPane(0,0));	

	int i,j,k;

	LogPtr->FINAL_PASS.Empty();
	LogPtr->FINAL_USER.Empty();
	
	siteptr = (CEdit *) GetDlgItem(ID_SITE);		
	i = siteptr->GetWindowText(LogPtr->site_addr,sizeof LogPtr->site_addr-1);
	
	userptr = (CEdit *) GetDlgItem(ID_USER);
	j = userptr->GetWindowText(LogPtr->username,sizeof LogPtr->username-1);

	passptr = (CEdit *) GetDlgItem(ID_PASS);
	k = passptr->GetWindowText(LogPtr->password,sizeof LogPtr->password-1);

	//Add the USER and PASS 
	LogPtr->FINAL_USER += LogPtr->user_head;
	LogPtr->FINAL_PASS += LogPtr->pass_head;
	
	//add the login and password given
	LogPtr->FINAL_USER +=LogPtr->username; 
	LogPtr->FINAL_USER += LogPtr->tail;

	LogPtr->FINAL_PASS += LogPtr->password;
	LogPtr->FINAL_PASS += LogPtr->tail;
	
	IfCancel = FALSE;	//to call ConnectInfo after this

	EndDialog(0);
}

/**********************************************************/
/////	for MAIL
afx_msg void C_Dialog :: OnMailOK() 
{
	SOCKET S;
	struct sockaddr_in A;
	struct hostent *H;
	
	
	char Message[4096];
	char From[4096];
	char Host[4096];
	char To[4096];
	
	char R[4096];
	int i;

	CString tail1 = "\r\n";
	CString tail2 = ">\r\n";
	CString Hello = "HELO ";
	CString MAILTO= "RCPT TO:<";
	CString MAILFROM= "MAIL FROM:<";

	CString DATA= "DATA\r\n";
	CString END=".\r\n";
	CString QUIT="QUIT\r\n";

	CString FINAL_TO;
	CString FINAL_FROM;
	CString FINAL_HOST;
	CString FINAL_HELO;


	CEdit *from_host = (CEdit *)GetDlgItem(IDC_HOST);
	CEdit *from_to   = (CEdit *)GetDlgItem(IDC_TO);
	CEdit *from_mess = (CEdit *)GetDlgItem(IDC_MESSAGE);
	CEdit *from_from = (CEdit *)GetDlgItem(IDC_FROM);

	from_host->GetWindowText(Host,sizeof Host);
	from_to ->GetWindowText(To,sizeof To);
	from_from->GetWindowText(From,sizeof From);
	from_mess->GetWindowText(Message,sizeof Message);

	S = socket(AF_INET, SOCK_STREAM, 0);
	
	A.sin_family = AF_INET;
	A.sin_port = htons(25);
	H = gethostbyname(Host);

	
	if( (WSAGetLastError() == WSAHOST_NOT_FOUND))
	{
		MessageBox("Unable to Resolve Host Name","Failure...",MB_OK | MB_ICONSTOP | MB_ICONSTOP);	
		return;				
	}


	A.sin_addr.s_addr = *((unsigned long *) H->h_addr);

	i = connect(S, (struct sockaddr *)&A, sizeof(A));

	if( (i == WSAECONNREFUSED) || (i == WSAETIMEDOUT))
	{
		MessageBox("Unable to Connect","Failure...",MB_OK | MB_ICONSTOP);
		return;		
	}
	
	FINAL_HELO +=From;
	FINAL_HELO +=tail1;
	send(S,FINAL_HELO, strlen(FINAL_HELO),0);
	recv(S, R , 4096, 0);

	FINAL_FROM += From;
	FINAL_FROM += tail2;
	send(S,FINAL_FROM, strlen(FINAL_FROM),0);
	recv(S, R , 4096, 0);

	FINAL_TO +=To;
	FINAL_TO +=tail2;
	send(S,FINAL_TO, strlen(FINAL_TO), 0);
	recv(S, R , 4096, 0);

	send(S,DATA, strlen(DATA), 0);
	recv(S, R , 4096, 0);

	send(S,Message, strlen(Message), 0);
	recv(S, R , 4096, 0);

	send(S,END, strlen(END), 0);
	recv(S, R , 4096, 0);

	send(S,QUIT, strlen(QUIT), 0);
	recv(S, R , 4096, 0);
		
	closesocket(S);

	MessageBox("Mail Sent","SENT",MB_OK);
	EndDialog(0);

}
/**********************************************************/
//	message map for the transfer settign dialog
BEGIN_MESSAGE_MAP(C_Transfer, CDialog)
//{	
	ON_COMMAND(IDOK, OnOK)	
//}
END_MESSAGE_MAP()
/**********************************************************/
BOOL C_Transfer::OnInitDialog()
{
	CDialog::OnInitDialog();

	CButton *bptr = (CButton *)GetDlgItem(IDS_BINARY);
	CButton *bptr2 = (CButton *)GetDlgItem(IDS_ASCII);

	
	bptr2->SetCheck(ASCII_stat);
	bptr->SetCheck(bin_stat);

	
	return TRUE;
}

/**********************************************************/
afx_msg void C_Transfer::OnOK() 
{

	CButton *bptr = (CButton *)GetDlgItem(IDS_ASCII);
	CButton *bptr2 = (CButton *)GetDlgItem(IDS_BINARY);

	ASCII_stat = bptr->GetCheck();
	bin_stat =  bptr2->GetCheck();
	
	EndDialog(0);
}

/**********************************************************/
//for loading
BEGIN_MESSAGE_MAP(C_Loading, CDialog)
//{
	ON_COMMAND(IDOK, OnOK)
	
//}
END_MESSAGE_MAP()
// for automated Sending And Receving
afx_msg void C_Loading::OnOK() 
{
	CString UP;
	CString Tail="\r\n";
	CString FileName;

	char File[30];
	
	CEdit *ptr=(CEdit *)GetDlgItem(IDC_EDIT1);

	C_MainWin *mainPtr = (C_MainWin *)AfxGetMainWnd();
	ASSERT(mainPtr != NULL);

	//get the pointer of the CView class
	C_LogView *LogPtr = (C_LogView *)(mainPtr->m_wndSplitter.GetPane(0,0));	
	
	ptr->GetWindowText(File,sizeof File);

	FileName = File;
	
	if(What == 1)
		UP="STOR ";

	if(What == 2)
		UP="RETR ";
	
	UP += FileName;
	UP += Tail;
	
	LogPtr->Send_Command(UP);

	EndDialog(1);
}
