#include <afxwin.h>
#include <afxext.h> //for the splitter window

#include "MainWin.h"
#include "WinApp.h"
#include "LogView.h"
#include "CommandView.h"


#define SOCK_LISTEN_FRAME_EVENT	 WM_USER+9
#define SOCK_DATA_FRAME_EVENT	 WM_USER+11
#define SOCK_CONTROL_FRAME_EVENT WM_USER+13

IMPLEMENT_DYNCREATE(C_MainWin, CFrameWnd);

BEGIN_MESSAGE_MAP(C_MainWin, CFrameWnd)

	ON_MESSAGE(SOCK_LISTEN_FRAME_EVENT,  Listen_FRAME_Message) 
	ON_MESSAGE(SOCK_DATA_FRAME_EVENT,Data_FRAME_Message)
	ON_MESSAGE(SOCK_CONTROL_FRAME_EVENT, Ctlr_FRAME_Message)

	ON_NOTIFY_RANGE(TTN_NEEDTEXT, 0 , IDR_MAINFRAME, OnTTip)
	ON_WM_CREATE()


END_MESSAGE_MAP()

BOOL C_MainWin :: OnCreateClient(LPCREATESTRUCT lpcd, CCreateContext * pContext)
{
	m_wndSplitter.CreateStatic(this,2,1);
	
	
	//teh lower window for th e command
	m_wndSplitter.CreateView(1,0, RUNTIME_CLASS(C_CommandView), CSize(0,0),pContext);

	//the upper window for the server reply
	m_wndSplitter.CreateView(0,0, RUNTIME_CLASS(C_LogView), CSize(600,300),pContext);
	
	ShowWindow(SW_SHOWMAXIMIZED);

		
	m_TB.CreateEx(this, TBSTYLE_FLAT  , WS_CHILD | WS_VISIBLE | CBRS_TOP 
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	if(!m_TB.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create 
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_TB.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_TB);

	return TRUE;
}

//to send the control socket message to the C_LogView
void C_MainWin::Ctlr_FRAME_Message(WPARAM wParam, LPARAM lParam)
{
	C_LogView *LogView = (C_LogView *)(m_wndSplitter.GetPane(0,0));

	LogView->SendMessage(SOCK_CONTROL_EVENT, wParam, lParam);

	return;
}

//to send Listen socket message to the C_LogView
void C_MainWin::Listen_FRAME_Message(WPARAM wParam, LPARAM lParam)
{
	C_LogView *LogView = (C_LogView *)(m_wndSplitter.GetPane(0,0));

	LogView->SendMessage(SOCK_LISTEN_EVENT, wParam, lParam);

	return; 
}



//to send the Data socket message to the C_LogView
void C_MainWin::Data_FRAME_Message(WPARAM wParam, LPARAM lParam)
{
	C_LogView *LogView = (C_LogView *)(m_wndSplitter.GetPane(0,0));

	LogView->SendMessage(SOCK_DATA_EVENT, wParam, lParam);

	return;
}

//for the ToolTip
afx_msg void C_MainWin::OnTTip(UINT idNotUsed, NMHDR *hdr, LRESULT *ResultNotUsed)
{
	switch(hdr->idFrom)	{
	case IDM_CONNECT_SOCK:
		((TOOLTIPTEXT *)hdr)->lpszText = "Connect";
		break;

	case IDM_CLOSE_SOCK:
		((TOOLTIPTEXT *)hdr)->lpszText = "Close Connection";
		break;

	case IDM_MAIL:
		((TOOLTIPTEXT *)hdr)->lpszText = "Send Anonymous E-mail";
		break;

	case IDT_CANCEL:
		((TOOLTIPTEXT *)hdr)->lpszText = "Cancel Transfer";
		break;

	case IDH_ABOUT:
		((TOOLTIPTEXT *)hdr)->lpszText = "About";
		break;
	}
}